#!/bin/sh

for md in /dev/md* ; do
	if [ -b "${md}" ]; then
		wipefs -a -f "${md}" >> /tmp/wipe.log
		echo "wiped ${part}" >> /tmp/wipe.log
		mdadm --stop ${md}
		echo "stopped ${md}" >> /tmp/wipe.log
	fi
done
for part in $(list-devices partition); do
	if [ -b "${part}" ]; then
		wipefs -a -f ${part} >> /tmp/wipe.log
		echo "wiped ${part}" >> /tmp/wipe.log
	fi
done
for disk in $(list-devices disk); do
	if [ -b "${disk}" ]; then
		wipefs -a -f ${disk} >> /tmp/wipe.log
		dd if=/dev/zero of=${disk} bs=512 count=32
		blkdiscard --secure ${disk}
		echo "wiped ${disk}" >> /tmp/wipe.log
	fi
done

set $(list-devices disk)
let numb=$#/2
DISKA=$1
DISKB=$2

debconf-set partman-basicfilesystems/choose_label gpt
debconf-set partman-partitioning/choose_label gpt
debconf-set partman-basicfilesystems/default_label gpt
debconf-set partman-partitioning/default_label gpt
debconf-set partman-partitioning/choose_label gpt
debconf-set partman-auto/disk "$DISKA"
debconf-set partman-auto/method "regular"

bootsize=525
efisize=525
swapsize=2098

if [ -d /sys/firmware/efi ]; then
	debconf-set partman-auto/expert_recipe "boot-root :: \
		 ${efisize} 200 ${efisize} free $iflabel{ gpt } $reusemethod{ } label{ EFI } method{ efi } format{ } . \
		 ${bootsize} 50 ${bootsize} ext4 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext4 } label{ BOOT } mountpoint{ /boot } . \
		 132 500 ${swapsize} linux-swap method{ swap } format{ } label{ SWAP } . \
		 4195 10000 -1 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } label{ ROOT } mountpoint{ / } . "
else
	debconf-set partman-auto/expert_recipe "boot-root :: \
		 2 1 2 free $iflabel{ gpt } method{ biosgrub } . \
		 ${bootsize} 50 ${bootsize} ext4 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext4 } label{ BOOT } mountpoint{ /boot } . \
		 132 500 ${swapsize} linux-swap method{ swap } format{ } label{ SWAP } . \
		 4195 10000 -1 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } label{ ROOT } mountpoint{ / } . "
fi

debconf-set grub-installer/bootdev "${DISKA}"
echo "${DISKA}" >> /tmp/grub_devices
