#!/bin/sh

for md in /dev/md* ; do \
	if [ -b "${md}" ]; then \
		wipefs -a -f "${md}" >> /tmp/wipe.log; \
		echo "wiped ${part}" >> /tmp/wipe.log; \
		mdadm --stop ${md}; \
		echo "stopped ${md}" >> /tmp/wipe.log; \
	fi; \
done; \
for part in $(list-devices partition); do \
	if [ -b "${part}" ]; then \
		wipefs -a -f ${part} >> /tmp/wipe.log; \
		echo "wiped ${part}" >> /tmp/wipe.log; \
	fi; \
done; \
for disk in $(list-devices disk); do \
	if [ -b "${disk}" ]; then \
		wipefs -a -f ${disk} >> /tmp/wipe.log; \
		dd if=/dev/zero of=${disk} bs=512 count=32; \
		echo "wiped ${disk}" >> /tmp/wipe.log; \
	fi; \
done; \

set $(list-devices disk); \
let numb=$#/2; \
DISKA=$1; \
DISKB=$2; \
SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
if [ -b "${DISKB}" ]; then \
	SIZE1=$(fdisk -l "${DISKA}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
	SIZE2=$(fdisk -l "${DISKB}" 2>/dev/null|grep Disk|grep dev|cut -d' ' -f5); \
	if [ -n ${SIZE1} ] && [ -n ${SIZE2} ] && [ "${SIZE1}" = "${SIZE2}" ]; then \
		USE_MIRROR=yes; \
	else \
		USE_MIRROR=no; \
	fi; \
fi; \

bootsize=512
efisize=512

debconf-set partman-basicfilesystems/choose_label gpt ;\
debconf-set partman-partitioning/choose_label gpt ;\
debconf-set partman-basicfilesystems/default_label gpt ;\
debconf-set partman-partitioning/default_label gpt ;\
debconf-set partman-partitioning/choose_label gpt ;\
if [ "#${USE_MIRROR}" = "#yes" ]; then \
	debconf-set partman-auto/disk "$DISKA $DISKB";\
	debconf-set partman-auto/method "raid";\
	if [ -d /sys/firmware/efi ]; then \
		debconf-set partman-auto/expert_recipe "multiraid :: \
		 ${efisize} 200 ${efisize} free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
		 ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
		 128 512 100% raid method{ raid } . \
		 1024 10000 1000000000 raid method{ raid } . ";\
	else \
		debconf-set partman-auto/expert_recipe "multiraid :: \
		 2 1 2 free $iflabel{ gpt } method{ biosgrub } . \
		 ${bootsize} 50 ${bootsize} raid $primary{ } method{ raid } . \
		 128 512 100% raid method{ raid } . \
		 1024 10000 1000000000 raid method{ raid } . ";\
	fi ;\
	debconf-set partman-auto-raid/recipe " \
		 1 2 0 ext2 /boot ${DISKA}2#${DISKB}2 . \
		 1 2 0 swap - ${DISKA}3#${DISKB}3 . \
		 1 2 0 ext4 / ${DISKA}4#${DISKB}4 . ";\
#	debconf-set grub-installer/bootdev "${DISKA} ${DISKB}";\
	echo "${DISKA} ${DISKB}" >> /tmp/grub_devices ;\
else \
	debconf-set partman-auto/disk "$DISKA";\
	debconf-set partman-auto/method "regular";\
	if [ -d /sys/firmware/efi ]; then \
		debconf-set partman-auto/expert_recipe "boot-root :: \
			 ${efisize} 200 ${efisize} free $iflabel{ gpt } $reusemethod{ } method{ efi } format{ } . \
			 ${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
			 128 512 100% linux-swap method{ swap } format{ } . \
			 1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
	else \
		debconf-set partman-auto/expert_recipe "boot-root :: \
			 2 1 2 free $gptonly{ } $primary{ } $bios_boot{ } method{ biosgrub } . \
			 ${bootsize} 50 ${bootsize} ext2 $primary{ } $bootable{ } method{ format } format{ } use_filesystem{ } filesystem{ ext2 } mountpoint{ /boot } . \
			 128 512 100% linux-swap method{ swap } format{ } . \
			 1024 10000 1000000000 ext4 method{ format } format{ } use_filesystem{ } filesystem{ ext4 } mountpoint{ / } . ";\
	fi ;\
	debconf-set grub-installer/bootdev "$DISKA";\
fi ;\
echo ok
